/*hdr
**      FILE:           Base64.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           1/6/98
**      DESCRIPTION:    Base64 encoding/decoding
**
**      Copyright (C) 1998, Matthew Allen
**              55 Kensignton Rd, Bolwarra, 2320, NSW, Australia
**              fret@ozemail.com.au
*/

#include "defs.h"
#include "base64.h"

uchar Base64ToBin(char c)
{
	if (c >= 'A' AND c <= 'Z')
	{
		return c - 'A';
	}

	if (c >= 'a' AND c <= 'z')
	{
		return c - 'a' + 26;
	}

	if (c >= '0' AND c <= '9')
	{
		return c - '0' + 52;
	}

	if (c == '+')
	{
		return 62;
	}

	if (c == '/')
	{
		return 63;
	}

	return 0;
}

char BinToBase64(uchar c)
{
	if (c >= 0 AND c <= 25)
	{
		return c + 'A';
	}

	if (c >= 26 AND c <= 51)
	{
		return c - 26 + 'a';
	}

	if (c >= 52 AND c <= 61)
	{
		return c - 52 + '0';
	}

	if (c == 62)
	{
		return '+';
	}

	if (c == 63)
	{
		return '/';
	}

	return 0;
}

int ConvertBase64ToBinary(uchar *Binary, int OutBuf, char *Base64, int InBuf)
{
	int Status = 0;

	if (Binary AND OutBuf > 0 AND Base64 AND InBuf > 0)
	{
		while (InBuf >= 4 AND OutBuf >= 3)
		{
			int Temp[4];

			Temp[0] = Base64ToBin(Base64[0]);
			Temp[1] = Base64ToBin(Base64[1]);
			Temp[2] = Base64ToBin(Base64[2]);
			Temp[3] = Base64ToBin(Base64[3]);

			Binary[0] = (Temp[0] << 2) | (Temp[1] >> 4);
			Binary[1] = (Temp[1] << 4) | (Temp[2] >> 2);
			Binary[2] = (Temp[2] << 6) | (Temp[3]);

			Binary += 3;
			OutBuf -= 3;
			Status += (Base64[2] == '=') ? 1 : (Base64[3] == '=') ? 2 : 3;

			Base64 += 4;
			InBuf -= 4;
		}
	}

	return Status;
}

int ConvertBinaryToBase64(char *Base64, int OutBuf, uchar *Binary, int InBuf)
{
	int Status = 0;

	if (Binary AND OutBuf > 0 AND Base64 AND InBuf > 0)
	{
		while (OutBuf >= 4 AND InBuf > 0)
		{
			Base64[0] = BinToBase64(Binary[0] >> 2);

			if (InBuf > 1)
			{
				Base64[1] = BinToBase64(((Binary[0] & 3) << 4) | (Binary[1] >> 4));
				if (InBuf > 2)
				{
					Base64[2] = BinToBase64(((Binary[1] & 0xF) << 2) | (Binary[2] >> 6));
					Base64[3] = BinToBase64(Binary[2] & 0x3F);
				}
				else
				{
					Base64[2] = BinToBase64((Binary[1] & 0xF) << 2);
					Base64[3] = '=';
				}
			}
			else
			{
				Base64[1] = BinToBase64(Binary[0] << 4);
				Base64[2] = '=';
				Base64[3] = '=';
			}

			Binary += 3;
			InBuf -= 3;

			Base64 += 4;
			OutBuf -= 4;
			Status += 4;
		}
	}

	return Status;
}

